#include <iostream>
#include <cmath>

const int flipNumber(const int& number)
{
  const int zeroValue(0);
  const int negativeValue(-1);
  const int mainRank(10);

  int originalNumber(number);
  int flippedNumber;

  if (zeroValue != originalNumber)
  {
    bool isValueNegative(false);

    if (zeroValue > originalNumber)
    {
      isValueNegative = true;
      originalNumber *= negativeValue;
    }

    const int numberRank         ( static_cast<int>(log10(originalNumber))       );
    const int rankMultiplier     ( pow(mainRank, numberRank)                     );
    const int lastDigitInNumber  ( originalNumber % mainRank                     );
    const int firstDigitInNumber ( originalNumber / rankMultiplier               );
    const int remainedNumberPart ( ( originalNumber - firstDigitInNumber * rankMultiplier ) / mainRank );

    flippedNumber = lastDigitInNumber * rankMultiplier + remainedNumberPart * mainRank + firstDigitInNumber;

    if (true == isValueNegative)
    {
      flippedNumber *= negativeValue;
    }
  }

  return flippedNumber;
}

int main()
{
  int originalNumber(1346);

  std::cout << "Original number: " << originalNumber << std::endl;
  std::cout << "Flipped number:  " << flipNumber(originalNumber)  << std::endl;

  return 0;
}


